#ifndef ARENA_H
#define ARENA_H

#include "../aliases.h"
#include <stdbool.h>

typedef struct {
  u64 capacity;
  u8 *buf;
  u8 *offset;
} arena_t;

bool arena_init(arena_t *arena, u64 capacity);
u8 *arena_alloc(arena_t *arena, u64 size);
void arena_clear(arena_t *arena);
void arena_free(arena_t *arena);

#endif // !ARENA_H
